# Plot functions of PyStepCorm
# Yunbo Wang
# wangyunbo0527@gmail.com


import os
import numpy as np
from scipy import integrate
from scipy.optimize import curve_fit
import matplotlib as plt
import pandas as pd
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.by import By
from selenium.webdriver.chrome.service import Service
from selenium.webdriver.chrome.options import Options
import time

def download_file(email_s,password,RSN_number,headless=True):
    # chrome_options = Options()
    #
    # prefs = {"download.default_directory": link}
    # chrome_options.add_experimental_option("prefs", prefs)
    # if brower_jump == False:
    #     chrome_options.add_argument("--headless")
    if headless == True:
        options = Options()
        options.add_argument("--headless")
        # options.add_argument("--no-sandbox")  # Bypass OS security model
        # options.add_argument("--disable-dev-shm-usage")  # Overcome limited resource problems
        # options.add_argument("--disable-gpu")
        # options.add_argument('--remote-debugging-pipe')
        browser = webdriver.Chrome(options=options)
    else:
        browser = webdriver.Chrome()


    browser.get('https://ngawest2.berkeley.edu/spectras/new?sourceDb_flag=1')
    email = browser.find_element(By.ID, "user_email")
    pw = browser.find_element(By.ID, "user_password")
    email.send_keys(email_s)
    # email.send_keys(Keys.RETURN)
    pw.send_keys(password)
    # pw.send_keys(Keys.RETURN)
    sign_in = browser.find_element(By.XPATH,'// *[ @ id = "user_submit"]')
    sign_in.click()
    time.sleep(2)
    print("signed in Successfully")

    # wait for the submit button
    submit = browser.find_element(By.XPATH, "//div[@id = 'buttons']/button")
    submit.click()
    time.sleep(5)

    # wait for search
    RSN = browser.find_element(By.ID, "search_search_nga_number")
    RSN.send_keys(RSN_number)
    search = browser.find_element(By.XPATH, "//div[@class = 'left_column']/fieldset/button")
    search.click()
    time.sleep(5)
    print("RSN Number is input")

    #### download
    print("Download is initializing")
    download = browser.find_element(By.XPATH, '//*[@id="middle_submit"]/fieldset[3]/button[2]')
    time.sleep(2)
    download.click()
    alert1 = browser.switch_to.alert
    print(alert1.text)
    alert1.accept()
    alert2 = browser.switch_to.alert
    print(alert2.text)
    alert2.accept()
    print("Please wait until the download is finished")
    time.sleep(6)

    return print('The download has been finished')




# # browser = webdriver.Chrome()
# # browser.get('https://ngawest2.berkeley.edu/spectras/new?sourceDb_flag=1')
# email = browser.find_element(By.ID, "user_email")
# pw = browser.find_element(By.ID, "user_password")
# email.send_keys("yunbo.wang.pro@gmail.com")
# email.send_keys(Keys.RETURN)
# pw.send_keys("wangyunbo@135")
# pw.send_keys(Keys.RETURN)
# submit = browser.find_element(By.XPATH, "//div[@id = 'buttons']/button")
# submit.click()
#
# RSN = browser.find_element(By.ID, "search_search_nga_number")
# RSN.send_keys("1002")
# RSN.send_keys(Keys.RETURN)
#
# search = browser.find_element(By.XPATH, "//div[@class = 'left_column']/fieldset/button")
# search.click()
#
#
# #
# # /html/body/div/div[8]/div/form/div[3]/fieldset[3]/button[2]
# # //*[@id="middle_submit"]/fieldset[3]/button[2]
# download = browser.find_element(By.XPATH,'//*[@id="middle_submit"]/fieldset[3]/button[2]')
# download.click()
#
#
#
# alert1 = browser.switch_to.alert
# print(alert1.text)
# alert1.accept()
# alert2 = browser.switch_to.alert
# print(alert2.text)
# alert2.accept()
#
# chrome_options = Options()
# chrome_options.add_argument("--headless")
# prefs = {"download.default_directory" : "/home/quantumsup/Downloads/NGA_TEST"}
# chrome_options.add_experimental_option("prefs", prefs)






# < fieldset
# 
# 
# class ="peer_nga_spectrum box_full_width" >
# 
# < legend > Download
# Options < / legend >
# < br >
# 
# < button
# type = "button"
# onclick = "getSaveSearchResult()" > Download
# Search
# Results(metadata + spectra) < / button >
# 
# < button
# type = "button"
# onclick = "getSelectedResult(true)" > Download
# Time
# Series
# Records(metadata + spectra + traces) < / button >
# 
# < !--              -->
# 
# < / fieldset >
# 定位用户名和密码输入框


if __name__ == '__main__':
    email_s = "yunbo.wang.pro@gmail.com"
    password = "wangyunbo@135"
    # RSN_number = '1501,900,1194,4716,180,6952,3744,6953,2507,8090,776,'
    RSN_number ='1501'
    link = "/home/quantumsup/Downloads/NGA_TEST"
    # brower_jump = False
    # download_file(email_s, password, RSN_number, link, brower_jump=False)
    headless = True
    download_file(email_s, password, RSN_number, headless)

    # for i in RSN_numbers:
    #     RSN_number = RSN_number + str(i) + ','




