# Plot functions of PyStepCorm
# Yunbo Wang
# wangyunbo0527@gmail.com


import os
import subprocess
import argparse
import numpy as np
# from scipy import integrate
# from scipy.optimize import curve_fit
# import matplotlib as plt
import pandas as pd
from selenium import webdriver
from selenium.webdriver.common.keys import Keys
from selenium.webdriver.common.by import By
from selenium.webdriver.chrome.service import Service
from selenium.webdriver.chrome.options import Options
import time
import argparse

def download_file_backend(email_s, password):
    # chrome_options = Options()
    #
    # prefs = {"download.default_directory": link}
    # chrome_options.add_experimental_option("prefs", prefs)
    # if brower_jump == False:
    #     chrome_options.add_argument("--headless")

####################################################################
    # html_widget = widgets.HTML(
    #     value='<div class="message-container" style="font-size: 20px;">Username and Password have been recorded</div>'
    # )

    # message_label = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">Username and Password have been recorded</div>'
    # )

    # container = widgets.HBox([message_label], layout=widgets.Layout(align_items='center'))
    # display(container)
######################################################################
    # if headless == True:
    #     options = Options()
    #     options.add_argument("--headless")
    #     options.add_argument("--no-sandbox")  # Bypass OS security model
    #     options.add_argument("--disable-dev-shm-usage")  # Overcome limited resource problems
    #     options.add_argument("--disable-gpu")
    #     options.add_argument('--remote-debugging-pipe')
    #     browser = webdriver.Chrome(options=options)
    # else:
    #     browser = webdriver.Chrome()
    options = Options()
    # options.add_argument("--headless")
    # options.add_argument("--headless=new")
    # options.add_argument("--no-sandbox")  # Bypass OS security model
    options.add_argument("--disable-dev-shm-usage")  # Overcome limited resource problems
    options.add_argument("--disable-gpu")
    # options.add_argument('--remote-debugging-pipe')
    browser = webdriver.Chrome(options=options)

    df = pd.read_csv(os.getcwd() + './Outputs/selected_motions.csv')
    RSN_numbers = (df.loc[:, 'RSN']).values
    RSN_number = ''
    for i in RSN_numbers:
        RSN_number = RSN_number + str(i) + ','

    # message_label1 = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">RSN number has been get.</div>'
    # )
    #
    # container1 = widgets.HBox([message_label1], layout=widgets.Layout(align_items='center'))
    # display(container1)

    print(RSN_number)


    browser.get('https://ngawest2.berkeley.edu/spectras/new?sourceDb_flag=1')
    email = browser.find_element(By.ID, "user_email")
    pw = browser.find_element(By.ID, "user_password")
    email.send_keys(email_s)
    # email.send_keys(Keys.RETURN)
    pw.send_keys(password)
    # pw.send_keys(Keys.RETURN)
    sign_in = browser.find_element(By.XPATH, '// *[ @ id = "user_submit"]')
    sign_in.click()
    time.sleep(5)
    ##########################################################
    ## check if the username is right
    # / html / body / div / div[8] / div / p
    # Invalid email or password.
    if_success = browser.find_element(By.XPATH, '// *[ @ id = "notice"]')
    alert = browser.find_element(By.XPATH, '//*[@id="content"]/p')

    if if_success.text == 'Signed in successfully.':
        print('Signed in successfully.')
    elif alert.text == 'Invalid email or password.':
        return ('Invalid email or password.')












    alert = browser.find_element(By.XPATH,  '//*[@id="content"]/p')
    # alert = browser.find_element(By.XPATH,  '// *[ @ id = "content"] / p[@class = 'alert')
    # alert = browser.find_element(By.XPATH, '/ html / body / div / div[8] / div / p')
    # alert = browser.find_element(By.CLASS_NAME, 'alert')
    if alert.text == 'Invalid email or password.':
        print('Invalid email or password.')




    ###########################################################

    # message_label2 = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">Signed in to the NGA-WEST2 Successfully.</div>'
    # )
    #
    # container2 = widgets.HBox([message_label2], layout=widgets.Layout(align_items='center'))
    # display(container2)
    print('Username and Password have been recorded')

    # wait for the submit button
    submit = browser.find_element(By.XPATH, "//div[@id = 'buttons']/button")
    submit.click()
    time.sleep(5)

    # wait for search
    RSN = browser.find_element(By.ID, "search_search_nga_number")
    RSN.send_keys(RSN_number)
    search = browser.find_element(By.XPATH, "//div[@class = 'left_column']/fieldset/button")
    search.click()
    time.sleep(5)
    # print("RSN Number is input")
    #
    # #### download
    # print("Download is initializing")

    # message_label3 = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">RSN Number is input and Download is initializing.</div>'
    # )
    #
    # container3 = widgets.HBox([message_label3], layout=widgets.Layout(align_items='center'))
    # display(container3)
    print('RSN Number is input and Download is initializing.')
    ##
    download = browser.find_element(By.XPATH, '//*[@id="middle_submit"]/fieldset[3]/button[2]')
    time.sleep(5)
    download.click()
    alert1 = browser.switch_to.alert
    print(alert1.text)
    alert1.accept()
    alert2 = browser.switch_to.alert
    print(alert2.text)
    alert2.accept()
    # print("Please wait until the download is finished")
    # message_label4 = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">Please wait until the download is finished...</div>'
    # )
    #
    # container4 = widgets.HBox([message_label4], layout=widgets.Layout(align_items='center'))
    # display(container4)
    print('>Please wait until the download is finished...')

    time.sleep(15)

    # message_label5 = widgets.HTML(
    #     # value='<div class="message-container">Username and Password have been recorded</div>'
    #     value='<div class="message-container" style="font-size: 20px;">The download has been finished.</div>'
    # )
    #
    # container5 = widgets.HBox([message_label5], layout=widgets.Layout(align_items='center'))
    # display(container5)
    print('The download has been finished.')

    return
# # browser = webdriver.Chrome()
# # browser.get('https://ngawest2.berkeley.edu/spectras/new?sourceDb_flag=1')
# email = browser.find_element(By.ID, "user_email")
# pw = browser.find_element(By.ID, "user_password")
# email.send_keys("yunbo.wang.pro@gmail.com")
# email.send_keys(Keys.RETURN)
# pw.send_keys("wangyunbo@135")
# pw.send_keys(Keys.RETURN)
# submit = browser.find_element(By.XPATH, "//div[@id = 'buttons']/button")
# submit.click()
#
# RSN = browser.find_element(By.ID, "search_search_nga_number")
# RSN.send_keys("1002")
# RSN.send_keys(Keys.RETURN)
#
# search = browser.find_element(By.XPATH, "//div[@class = 'left_column']/fieldset/button")
# search.click()
#
#
# #
# # /html/body/div/div[8]/div/form/div[3]/fieldset[3]/button[2]
# # //*[@id="middle_submit"]/fieldset[3]/button[2]
# download = browser.find_element(By.XPATH,'//*[@id="middle_submit"]/fieldset[3]/button[2]')
# download.click()
#
#
#
# alert1 = browser.switch_to.alert
# print(alert1.text)
# alert1.accept()
# alert2 = browser.switch_to.alert
# print(alert2.text)
# alert2.accept()
#
# chrome_options = Options()
# chrome_options.add_argument("--headless")
# prefs = {"download.default_directory" : "/home/quantumsup/Downloads/NGA_TEST"}
# chrome_options.add_experimental_option("prefs", prefs)






# < fieldset
# 
# 
# class ="peer_nga_spectrum box_full_width" >
# 
# < legend > Download
# Options < / legend >
# < br >
# 
# < button
# type = "button"
# onclick = "getSaveSearchResult()" > Download
# Search
# Results(metadata + spectra) < / button >
# 
# < button
# type = "button"
# onclick = "getSelectedResult(true)" > Download
# Time
# Series
# Records(metadata + spectra + traces) < / button >
# 
# < !--              -->
# 
# < / fieldset >
# 定位用户名和密码输入框


if __name__ == '__main__':
    # download_file()
    # # python NGA_WEST2_backend.py registered_email=yunbo.wang.pro@gmail.com password=wangyunbo@135 RSN=900
    #
    #
    # # Command to execute
    # command = "dir"  # Example command, you can replace it with any Windows command you want to run
    #
    # # Execute the command
    # result = subprocess.run(command, shell=True, capture_output=True, text=True)
    #
    # # Check if the command executed successfully
    # if result.returncode == 0:
    #     print("Command executed successfully.")
    #     # Print the output of the command
    #     print(result.stdout)
    # else:
    #     print("Error executing command.")
    #     # Print the error message
    #     print(result.stderr)

    email_s = "yunbo.wang.pro@gmail.com"
    password = "wangyunbo@135"
    download_file_backend(email_s, password)
    # RSN_number = '1501,900,1194,4716,180,6952,3744,6953,2507,8090,776,'
    # link = "/home/quantumsup/Downloads/NGA_TEST"
    # # brower_jump = False
    # # download_file(email_s, password, RSN_number, link, brower_jump=False)
    # headless = True
    # download_file(email_s, password, RSN_number, headless)
    #
    # # for i in RSN_numbers:
    # #     RSN_number = RSN_number + str(i) + ','




